
/*************************************************
	GLOBAL PROTOTYPES: polyutil.c
*************************************************/

#ifndef __polyutil_h
#define __polyutil_h


extern void
clear_rpoly(
#if NeedFunctionPrototypes
	Rpoly *poly
#endif
);

extern void
clear_ipoly(
#if NeedFunctionPrototypes
	Ipoly *poly
#endif
);

extern void
clear_poly_list(
#if NeedFunctionPrototypes
	Poly_list *list
#endif
);

extern void
clear_cir(
#if NeedFunctionPrototypes
	Cir *cir
#endif
);

extern void
init_rpoly(
#if NeedFunctionPrototypes
	Rpoly *poly
#endif
);

extern void
init_ipoly(
#if NeedFunctionPrototypes
	Ipoly *poly
#endif
);

extern void
init_poly_list(
#if NeedFunctionPrototypes
	Poly_list *list
#endif
);

extern void
init_cir(
#if NeedFunctionPrototypes
	Cir *cir,
	int nlev
#endif
);

extern void
add_rpoly_pt(
#if NeedFunctionPrototypes
	Rpoly *poly,
	Rtyp x,
	Rtyp y
#endif
);

extern void
add_ipoly_pt(
#if NeedFunctionPrototypes
	Ipoly *poly,
	int x,
	int y
#endif
);

extern void
ins_ipoly_pt(
#if NeedFunctionPrototypes
	Ipoly *poly,
	int x,
	int y,
	int (*cmp)()
#endif
);

extern void
insert_ipoly_pt(
#if NeedFunctionPrototypes
	Ipoly *ipoly,
	int ix,
	int iy,
	int ipt
#endif
);

extern Rpoly
*add_rpoly(
#if NeedFunctionPrototypes
	Poly_list *plist,
	Rtyp *xyp,
	int n
#endif
);

extern Ipoly
*add_ipoly(
#if NeedFunctionPrototypes
	Poly_list *plist,
	int *xyp,
	int n
#endif
);


extern void
remove_poly(
#if NeedFunctionPrototypes
	Poly_list *plist,
	int i
#endif
);

extern void
move_plev(
#if NeedFunctionPrototypes
	Poly_list *to,
	Poly_list *from
#endif
);

extern void
move_ipoly(
#if NeedFunctionPrototypes
	Ipoly *to,
	Ipoly *from
#endif
);

extern void
move_rpoly(
#if NeedFunctionPrototypes
	Rpoly *to,
	Rpoly *from
#endif
);

extern int
pt_in_rpoly(
#if NeedFunctionPrototypes
	Rpoly *poly,
	Rtyp x,
	Rtyp y
#endif
);

extern int
pt_in_ipoly(
#if NeedFunctionPrototypes
	Ipoly *poly,
	int x,
	int y
#endif
);

extern void
poly_rtoi(
#if NeedFunctionPrototypes
	Rpoly *rpoly,
	Ipoly *ipoly,
	Rtyp dx,
	Rtyp dy
#endif
);

extern void
add_vias(
#if NeedFunctionPrototypes
	Cir *cir,
	Box_info *Box
#endif
);

extern void
via2vxy(
#if NeedFunctionPrototypes
	Rpoly *poly,
	Rtyp *x0p,
	Rtyp dx,
	Rtyp dy,
	int typ,
	int **vxyp,
	int *nump
#endif
);

extern void
vxy2rpoly(
#if NeedFunctionPrototypes
	int *vxy,
	int num,
	Rpoly *poly,
	Rtyp dx,
	Rtyp dy
#endif
);

extern void
init_vias(
#if NeedFunctionPrototypes
	via_list *vias
#endif
);

extern void
clear_vias(
#if NeedFunctionPrototypes
	via_list *vias
#endif
);

extern int
add_e_via(
#if NeedFunctionPrototypes
	int poly_index,
	int ipt,
	int ilev,
	int typ,
	via_list *vias,
	int line_nu
#endif
);

extern void
ipoly_to_dupe_x(
#if NeedFunctionPrototypes
	Ipoly *poly0,
	int np,
	Ipoly *dupe,
	Poly_list *lines0,
	Box_info *Box
#endif
);

extern int
form_xpass(
#if NeedFunctionPrototypes
	Ipoly *lines,
	int nline,
	int ibot,
	int itop,
	int loc,
	int *pass0
#endif
);

extern void
tri_fill(
#if NeedFunctionPrototypes
	Ipoly *poly,
	msub_list *lev,
	Poly_list *plev,
	Box_info *Box
#endif
);

extern void
cor_fill(
#if NeedFunctionPrototypes
	Ipoly *poly,
	msub_list *lev,
	Poly_list *plev,
	Box_info *Box,
	int xlim,
	int ylim
#endif
);

extern int
getxdist(
#if NeedFunctionPrototypes
	int xa,
	int y,
	int xb
#endif
);

extern Rpoly
*copy_rpoly(
#if NeedFunctionPrototypes
	Rpoly *from
#endif
);

#endif  /* End: __polyutil_h */

